---
title: File drag and drop
slug: Web/API/HTML_Drag_and_Drop_API/File_drag_and_drop
tags:
  - Guide
  - drag and drop
  - drop zone
---
<p>{{DefaultAPISidebar("HTML Drag and Drop API")}}</p>

<p>HTML Drag and Drop interfaces enable web applications to drag and drop files on a web page. This document describes how an application can accept one or more files that are dragged from the underlying platform's <em>file manager</em> and dropped on a web page.</p>

<p>The main steps to drag and drop are to define a <em>drop zone</em> (i.e. a target element for the file drop) and to define event handlers for the {{event("drop")}} and {{event("dragover")}} events. These steps are described below, including example code snippets. The full source code is available in <a href="https://github.com/mdn/dom-examples/tree/master/drag-and-drop">MDN's drag-and-drop repository</a> (pull requests and/or issues are welcome).</p>

<p class="note">Note: {{domxref("HTML_Drag_and_Drop_API","HTML drag and drop")}} defines two different APIs to support dragging and dropping files. One API is the {{domxref("DataTransfer")}} interface and the second API is the {{domxref("DataTransferItem")}} and {{domxref("DataTransferItemList")}} interfaces. This example illustrates the use of both APIs (and does not use any Gecko specific interfaces).</p>

<h2 id="Define_the_drop_zone">Define the drop <em>zone</em></h2>

<p>The <em>target element</em> of the {{event("drop")}} event needs an {{domxref("GlobalEventHandlers.ondrop","ondrop")}} global event handler. The following code snippet shows how this is done with a {{HTMLelement("div")}} element:</p>

<pre class="brush: html">&lt;div id="drop_zone" ondrop="dropHandler(event);"&gt;
  &lt;p&gt;Drag one or more files to this Drop Zone ...&lt;/p&gt;
&lt;/div&gt;</pre>

<p>Typically, an application will include a {{event("dragover")}} event handler on the drop target element and that handler will turn off the browser's default drag behavior. To add this handler, you need to include a {{domxref("GlobalEventHandlers.ondragover","ondragover")}} global event handler:</p>

<pre class="brush: html">&lt;div id="drop_zone" ondrop="dropHandler(event);" ondragover="dragOverHandler(event);"&gt;
  &lt;p&gt;Drag one or more files to this Drop Zone ...&lt;/p&gt;
&lt;/div&gt;
</pre>

<p>Lastly, an application may want to style the drop target element to visually indicate the element is a drop zone. In this example, the drop target element uses the following styling:</p>

<pre class="brush: css">#drop_zone {
  border: 5px solid blue;
  width:  200px;
  height: 100px;
}
</pre>

<div class="note">
<p>Note that <code>dragstart</code> and <code>dragend</code> events are not fired when dragging a file into the browser from the OS.</p>
</div>

<h2 id="Process_the_drop">Process the drop</h2>

<p>The {{event("drop")}} event is fired when the user drops the file(s). In the following drop handler, if the browser supports {{domxref("DataTransferItemList")}} interface, the {{domxref("DataTransferItem.getAsFile","getAsFile()")}} method is used to access each file; otherwise the {{domxref("DataTransfer")}} interface's {{domxref("DataTransfer.files","files")}} property is used to access each file.</p>

<p>This example shows how to write the name of each dragged file to the console. In a <em>real</em> application, an application may want to process a file using  the {{domxref("File","File API")}}.</p>

<p>Note that in this example, any drag item that is not a file is ignored.</p>

<pre class="brush: js">function dropHandler(ev) {
  console.log('File(s) dropped');

  // Prevent default behavior (Prevent file from being opened)
  ev.preventDefault();

  if (ev.dataTransfer.items) {
    // Use DataTransferItemList interface to access the file(s)
    for (var i = 0; i &lt; ev.dataTransfer.items.length; i++) {
      // If dropped items aren't files, reject them
      if (ev.dataTransfer.items[i].kind === 'file') {
        var file = ev.dataTransfer.items[i].getAsFile();
        console.log('... file[' + i + '].name = ' + file.name);
      }
    }
  } else {
    // Use DataTransfer interface to access the file(s)
    for (var i = 0; i &lt; ev.dataTransfer.files.length; i++) {
      console.log('... file[' + i + '].name = ' + ev.dataTransfer.files[i].name);
    }
  }
}</pre>

<h2 id="Prevent_the_browser's_default_drag_behavior">Prevent the browser's default drag behavior</h2>

<p>The following {{event("dragover")}} event handler calls {{domxref("Event.preventDefault","preventDefault()")}} to turn off the browser's default drag and drop handler.</p>

<pre class="brush: js">function dragOverHandler(ev) {
  console.log('File(s) in drop zone');

  // Prevent default behavior (Prevent file from being opened)
  ev.preventDefault();
}
</pre>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/API/HTML_Drag_and_Drop_API">HTML Drag and Drop API</a></li>
	<li><a class="internal" href="/Web/Guide/HTML/Drag_operations" title="Drag Operations">Drag Operations</a></li>
	<li><a href="https://html.spec.whatwg.org/multipage/interaction.html#dnd" title="Drag and Drop Standard">HTML5 Living Standard: Drag and Drop</a></li>
</ul>
